#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "Templates/SubclassOf.h"
#include "K33P01.generated.h"

class UStatusEffect;
class ASurvivor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UK33P01 : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere)
	float _perkCooldownTime;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _screamRevealRangeFromLocker;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _blindedStatusEffect;

	UPROPERTY(EditAnywhere)
	float _blindedEffectDuration;

private:
	UFUNCTION(BlueprintCallable, NetMulticast, Reliable)
	void Multicast_SurvivorRevealed(const ASurvivor* survivor) const;

public:
	UFUNCTION(BlueprintPure)
	float GetScreamRevealRange() const;

	UFUNCTION(BlueprintPure)
	float GetPerkCooldownTimeAtLevel() const;

	UFUNCTION(BlueprintPure)
	float GetBlindedEffectDurationAtLevel() const;

public:
	UK33P01();
};

FORCEINLINE uint32 GetTypeHash(const UK33P01) { return 0; }
